#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleManager.h"

class FRenderTestModule : public IModuleInterface
{
public:
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;
	void PluginButtonClicked();
	
private:
	void AddToolbarExtension(class FToolBarBuilder& Builder);
	void AddMenuExtension(class FMenuBuilder& Builder);
	TSharedRef<class SDockTab> OnSpawnPluginTab(const class FSpawnTabArgs& SpawnTabArgs);
	TSharedPtr<class FUICommandList> PluginCommands;

	TSharedPtr<class FSceneViewport> Viewport;
	TSharedPtr<class SViewport> ViewportWidget;
	TSharedPtr<class FRenderTestViewportClient> ViewportClient;
};
